﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApp55
{
    public partial class Form1 : Form
    {
        private DataTable dt;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.dt = new DataTable();
            dt.Columns.Add("Name");
            dt.Columns.Add("City");

            if (true)
            {
                uteName.DataBindings.Add("Value", dt, "Name", true, DataSourceUpdateMode.OnPropertyChanged);
                uteName2.DataBindings.Add("Value", dt, "Name", true, DataSourceUpdateMode.OnPropertyChanged);
                uteCity.DataBindings.Add("Value", dt, "City", true, DataSourceUpdateMode.OnPropertyChanged);
            }
            else
            {
                tbName.DataBindings.Add("Text", dt, "Name", true, DataSourceUpdateMode.OnPropertyChanged);
                tbName2.DataBindings.Add("Text", dt, "Name", true, DataSourceUpdateMode.OnPropertyChanged);
                tbCity.DataBindings.Add("Text", dt, "City", true, DataSourceUpdateMode.OnPropertyChanged);
            }

            // New row
            dt.Rows.Add(dt.NewRow());

            dataGridView1.DataSource = dt;
        }

        private void btnShowDataSourceValues_Click(object sender, EventArgs e)
        {
            foreach (DataRow dataRow in this.dt.Rows)
            {
                Debug.WriteLine(dataRow["City"].ToString(), dataRow["Name"].ToString());
            }

            var changes = dt.GetChanges();
            foreach (DataRow dataRow in changes.Rows)
            {
                Debug.WriteLine(dataRow["City"].ToString(), dataRow["Name"].ToString());
            }
        }

        private void btnCommitChanges_Click(object sender, EventArgs e)
        {
            var bindingContext = this.BindingContext[this.dt];
            bindingContext.EndCurrentEdit();
        }
    }
}
